package com.map;

import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioButton;


public class CreateRouteForm extends Activity// implements Button.OnClickListener
 {
	
		private EditText street;
		private Button submit;
		private Button cancel;
		public Long mRowId;
		private DBAdapter db;
		
		private RadioButton source;
		private RadioButton destination;
		private String number;

	
	
	 @Override
	 public void onCreate(Bundle savedInstanceState) {
	       super.onCreate(savedInstanceState);
	       setContentView(R.layout.form);
	       db = new DBAdapter(this);  
	       db.open();
	     //db.deleteTable();
	       street = (EditText)findViewById(R.id.entry);
	       //postcode = (EditText)findViewById(R.id.postcode);
	       submit = (Button)findViewById(R.id.ok);
	       cancel = (Button)findViewById(R.id.cancel);
	       
	       source =(RadioButton)findViewById(R.id.radio_source);
	       destination =(RadioButton)findViewById(R.id.radio_destination);
	       //submit.setOnClickListener(this);

	    
	       mRowId = savedInstanceState != null ? savedInstanceState.getLong(DBAdapter.KEY_ROWID): null;
	       
	      if(mRowId == null) {
				Bundle extras = getIntent().getExtras(); 
				mRowId = extras != null ? extras.getLong(DBAdapter.KEY_ROWID) 
							: null;
			}
	       populateFields();
	       submit.setOnClickListener(new View.OnClickListener(){

				public void onClick(View v) {
					  // setResult(RESULT_OK);
						startActivity(new Intent(getBaseContext(), map.class));
						CreateRouteForm.this.finish();
					
				}
				
	    	});
	       cancel.setOnClickListener(new Button.OnClickListener(){

				public void onClick(View v) {
					startActivity(new Intent(getBaseContext(), map.class));
				    CreateRouteForm.this.finish();					
				}
	       });
	    
	   }
	 private void populateFields() {
	        if (mRowId != null) {
	            Cursor note = db.fetchAddress(mRowId);
	            startManagingCursor(note);
	            street.setText(note.getString(
	    	            note.getColumnIndexOrThrow(DBAdapter.KEY_STREET)));

	        }
	    }
	 
	 @Override
	    protected void onSaveInstanceState(Bundle outState) {
	        super.onSaveInstanceState(outState);
	        outState.putLong(DBAdapter.KEY_ROWID, mRowId);
	    }
	    
	    @Override
	    protected void onPause() {
	        super.onPause();
	        saveState();
	    }
	    
	    @Override
	    protected void onResume() {
	        super.onResume();
	        populateFields();
	    }
	    
	    private void saveState() {
	        String str = street.getText().toString();
	 
	        

	        String nb = number;
	        GlobalData globalData = GlobalData.getInstance();

	        String lt = globalData.lat;
	        String pc = globalData.lng;
	        
	        if (mRowId == null) 
	        {
	            long id = db.createAddress(str, pc, lt, nb); 
	            
	            if (id > 0)
	            {
	                mRowId = id;
	            }
	            db.close();
	        } 
	        else 
	        {
	            db.updateAddress(mRowId, str, pc, lt, nb);
	        }
	        db.close();
	    }
		public void onClick(View v) {
			if(v == submit)
			 {
			 if(source.isChecked() == true)
			 number = "0";
			 if(destination.isChecked() == true)
				 number = "1";
			 }
		}
	 
}