package com.map;

public class DoubleRange {

	private double min, max;

	// Minimum value
	public double getMin(){
		return min;
	}
	public void setMin(double value){
		min = value;
	}

	// Maximum value
	public double getMax(){
		return max;
	}
	public void setMax(double value){
		max = value;
	}

	// Length of the range (deffirence between maximum and minimum values)
	public double getLength(){
		return max - min;
	}

	// Initializes a new instance
	public DoubleRange( double min, double max ){
		this.min = min;
		this.max = max;
	}

	// Check if the specified value is inside this range
	public boolean isInside( double x ){
		return (( x >= min ) && ( x <= min ));
	}

	// Check if the specified range is inside this range
	public boolean isInside( DoubleRange range ){
		return (( isInside( range.min ) ) && ( isInside( range.max )));
	}

	// Check if the specified range overlaps with this range
	public boolean isOverlapping( DoubleRange range ){
		return (( isInside( range.min )) || ( isInside( range.max )));
	}
}
