package com.map;

public class Layer{
	
	// Layer's inputs count
	protected int		inputsCount = 0;
	
	// Layer's neurons count
	protected int		neuronsCount = 0;
	
	// Layer's neurons
    protected Neuron[] neurons;
    
    // Layer's output vector
	protected double[]	output;
	
	// Layer's inputs count
	public int getInputsCount(){
		return inputsCount;
	}
	
	// Layer's neurons count
	public int getNeuronsCount(){
		return neuronsCount;
	}
	
	// Layer's output vector
	public double[] getOutput(){
		return output;
	}
	
	// Compute output vector of the layer
	public  double[] Compute( double[] input )
	{
		for ( int i = 0; i < neuronsCount; i++ )
			output[i] = neurons[i].Compute( input );
		return output;
	}
	
	// Randomize neurons of the layer
	public  void Randomize( )
	{
        for (int i = 0; i < neuronsCount; i++)
            neurons[i].Randomize();
	}
	
	// Initializes a new instance
	public Layer( int neuronsCount, int inputsCount )
	{
		this.inputsCount	= Math.max( 1, inputsCount );
		this.neuronsCount	= Math.max( 1, neuronsCount );
        neurons = new Neuron[this.neuronsCount];
		output = new double[this.neuronsCount];
		for ( int i = 0; i < neuronsCount; i++ )
			neurons[i] = new Neuron( inputsCount );
	}
}
