package com.map;

public class Network{
	
	// Network's inputs count
	protected int	inputsCount;
	
	// Network's layers count
	protected int	layersCount;
	
	// Network's layers
	protected Layer	layers;
	
	// Network's output vector
	protected double[]	output;
	
	// Network's inputs count
	public int getInputsCount(){
		return inputsCount; 
	}
	
	// Network's layers count
	public int getLayersCount(){
		return layersCount;
	}
	
	// Network's output vector
	public double[] getOutput(){
		return output;
	}
	
	// Compute output vector of the network
	public double[] Compute( double[] input ){
		output = input;		
		output = layers.Compute( output );
		return output;
	}
	
	// Randomize layers of the network
	public void Randomize( ){
		layers.Randomize();
	}
	
	// Initializes a new instance
	public Network( int inputsCount, int neuronsCount ){
		this.inputsCount = Math.max( 1, inputsCount );
		this.layersCount = Math.max( 1, 1 );
		layers = new Layer( neuronsCount, inputsCount );
	}
	
	// Get winner neuron
	public int GetWinner( ){
		double	min = output[0];
		int		minIndex = 0;
		for ( int i = 1, n = output.length; i < n; i++ )
		{
			if ( output[i] < min )
			{
				min = output[i];
				minIndex = i;
			}
		}
		return minIndex;
	}
}
