package com.map;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;

public class OptimRoute extends Activity {
	// values of form
	private int citiesCount		= 10;
	private int neurons			= 20;
	private int	iterations		= 2000;
	private double learningRate	= 0.5;
	private double learningRadius = 0.5;
	
	// map

	private double[][] map;
	private String[] map1;
	Context mcontext;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.route);

		
		DBAdapter db;
      db = new DBAdapter(this); 
      map = new double[citiesCount][2];
      map1 = new String[citiesCount];
      db.open();
      int i=0;
      Cursor c = db.fetchAllAddress();
      if (c.moveToFirst())
      {
          do {
          	//mRowId, str, pc, lt, nb
          	map[i][0] = Double.parseDouble(c.getString(3));
          	map[i][1] = Double.parseDouble(c.getString(2));
          	map1[i]= c.getString(1);
          	i++;
          	
          	
          } while (c.moveToNext());
      }
      citiesCount =i;
     // db.deleteTable();


		
		// analysis of values from fields
	
		citiesCount=Math.max(2, citiesCount);
		citiesCount=Math.min(50, citiesCount);

		
	
		neurons=Math.max(2, neurons);
		neurons=Math.min(50, neurons);


	
		iterations=Math.max(10, iterations);
		iterations=Math.min(5000, iterations);

		
	
		learningRate=Math.max(0.1, learningRate);
		learningRate=Math.min(0.8, learningRate);

		
	
		learningRadius=Math.max(0.1, learningRadius);
		learningRadius=Math.min(0.8, learningRadius);

		
		// set random generators range
		Neuron.randRange = new DoubleRange( 0, 1000 );
	
		// create network
		Network network = new Network( 2, neurons );
	
		// create learning algorithm
		NetworkLearning	trainer = new NetworkLearning( network );
	
		double	fixedLearningRate = learningRate / 20;
		double	driftingLearningRate = fixedLearningRate * 19;
	
		// path
		double[][] path = new double[neurons + 1][2];
	
		// input
		double[] input = new double[2];
	
		// iterations
		i = 0;
	
		// loop		
		while (true){

			// update learning speed & radius
			trainer.setLearningRate(driftingLearningRate * ( iterations - i ) / iterations + fixedLearningRate);
			trainer.setLearningRadius(learningRadius * ( iterations - i ) / iterations);
			
			// set network input
			int currentCity = (int)(Math.random()*citiesCount);
			input[0] = map[currentCity][0];
			input[1] = map[currentCity][1];
			
			// run one training iteration
			trainer.Run( input );
			
			// save current path
			for ( int j = 0; j < neurons; j++ )
			{
				path[j][0] = network.layers.neurons[j].weights[0];
				path[j][1] = network.layers.neurons[j].weights[1];
			}
			path[neurons][0] = network.layers.neurons[0].weights[0];
			path[neurons][1] = network.layers.neurons[0].weights[1];
			
			// increase current iteration
			i++;
			
			// stop 
			if ( i >= iterations )
				break;
		}

		// return result as a text


		
		System.out.println("Sequence of the cities");


		double[][] answerCounter = new double[map.length][4];
		System.out.println(map.length);
		int counterCities = 1;
		double differenceTB1 = 0.0;
		double differenceTB2 = 0.0;
		for (int k = 0; k < neurons; k++){

			for (i = 0; i < map.length; i++){

				differenceTB1 = map[i][0]-path[k][0];
				differenceTB2 = +map[i][1]-path[k][1];
				
				if(differenceTB1<0)
					differenceTB1 = differenceTB1*-1;
				if(differenceTB2<0)
					differenceTB2 = differenceTB2*-1;
				
				if((differenceTB1<12)&&(differenceTB2<12)){
					
					System.out.println(""+counterCities+" "+i+ "  "+map[i][0]+"  "+map[i][1]);					
					
					answerCounter[counterCities-1][0]=counterCities;
					answerCounter[counterCities-1][1]=i;
					counterCities = counterCities+1;
					
				}
			}
		}	

		
		// counter from beginning point as city 0
		int increaser = 1;
		boolean flag = false;
		for (i = 0; i < map.length; i++){			
			if(answerCounter[i][1]==0){
				flag = true;
				answerCounter[i][0]= increaser;
				increaser = increaser+1;
			}else if(flag){
				answerCounter[i][0]= increaser;
				increaser = increaser+1;			
			}				
		}
		for (i = 0; i < map.length; i++){			
			if(answerCounter[i][1]==0){
				flag = false;
			}else if(flag){
				answerCounter[i][0]= increaser;
				increaser = increaser+1;			
			}				
		}
		
		// sorted answer
		int j;
		for (i = 0; i < map.length; i++){
			j = (int) answerCounter[i][1];
			db.createAddress(map1[j], Double.toString(map[j][1]), Double.toString(map[j][0]), Integer.toString(i));
		}
		db.close();
		
		startActivity(new Intent(this, map.class));
		this.finish();
		
	}

}
