package com.map;


import android.app.ListActivity;
import android.database.Cursor;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.SimpleCursorAdapter;


public class ViewAddresses extends ListActivity {
	
	private DBAdapter db;
	private SimpleCursorAdapter myAdapter;
	private Button back;
	private Button deleteAll;
	
	 public void onCreate(Bundle savedInstanceState) {
	       super.onCreate(savedInstanceState);
	       setContentView(R.layout.list);     
	       db = new DBAdapter(this); 
	       back = (Button)findViewById(R.id.back);
	       deleteAll = (Button)findViewById(R.id.delete);
	       db.open();
	        addData();
	        //registerForContextMenu(getListView());
	        
	        back.setOnClickListener(new View.OnClickListener(){

				public void onClick(View v) {
						ViewAddresses.this.finish();					
				}			
	    	});
	       
	        deleteAll.setOnClickListener(new View.OnClickListener(){

				public void onClick(View v) {
						db.deleteTable();
						ViewAddresses.this.finish();					
				}			
	    	});
	    }    
	 	
	 private void addData() {
	        Cursor cusor = db.fetchAllAddress();
	        startManagingCursor(cusor);
	                
	        // Create an array to specify the fields we want to display in the list (only TITLE)
	        String[] from = new String[]{DBAdapter.KEY_STREET, DBAdapter.KEY_LONG, DBAdapter.KEY_LATI};
	        
	        
	        // and an array of the fields we want to bind those fields to (in this case just text1)
	        int[] to = new int[]{R.id.street,R.id.longitude,R.id.latitude};
	       
	        // Now create a simple cursor adapter and set it to display
	        myAdapter = new SimpleCursorAdapter(this, R.layout.row, cusor, from, to);
	        
	        setListAdapter(myAdapter);
	        
	    } 
	 
}